<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         edit_category.php
Description:  Administrative module to edit categories or create new ones

*/

    include "../modules/class_category.php";
    include "../modules/class_categorylist.php";
    include "../modules/class_translation.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";

    $b_NotFinished = true;
    $b_ErrorOccured = false;
    $catId = "";
    $errorString = "";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }

    // Check action
    $catEdtAction = "new";
    if (isset ($_POST['cat_EdtAction']) == true)
    {
        if ($_POST['cat_EdtAction'] == "edit")
            $catEdtAction = "edit";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "edit")
            $catEdtAction = "edit";
    }

    $catCategory = new cCategory;
    $catCategory->SetFolder($CATEGORY_FOLDER);

    if ($catEdtAction == "edit")  // Edit -> load it
    {
        if (isset ($_POST['cat_id']) == true)
            $catId = $_POST['cat_id'];
        else if (isset ($_GET['id']) == true)
            $catId = $_GET['id'];
        if ($catCategory->LoadCategoryFromId($catId) == false)
        {
            print_error_message($cTrans->GetTranslation('admin_catedt_errorload') . ', ID: ' . $catId);
            return;
        }
    }

    // Category edit cancelled?
    if (isset ($_POST['cat_Cancel']))
    {
        header('location: ' . $ADMIN_CATLIST_SITE);
        return;
    }

    // Check for errors and if none, store the category values
    if (isset ($_POST['cat_Save']))
    {
        if (isset($_POST['cat_Name']) == false || $_POST['cat_Name'] == "")
        {
            $errorString = $cTrans->GetTranslation('admin_cat_errorname') . '!';
            $b_ErrorOccured = true;
        }
        else if (isset($_POST['cat_Description']) == false || $_POST['cat_Description'] == "")
        {
            $errorString = $cTrans->GetTranslation('admin_cat_errordescription') . '!';
            $b_ErrorOccured = true;
        }
        else if (isset($_POST['cat_Position']) == false || $_POST['cat_Position'] == "" || is_numeric($_POST['cat_Position']) == false)
        {
            $errorString = $cTrans->GetTranslation('admin_cat_errorposition') . '!';
            $b_ErrorOccured = true;
        }

        // Check double title
        if ($b_ErrorOccured == false)
        {
            if ($catEdtAction == "new" || ($_POST['cat_Name'] != $catCategory->GetName()))
            {
                $cList = new cCategoryList;
                $cList->SetFolder($CATEGORY_FOLDER);
                if ($cList->CheckName($_POST['cat_Name']) == false)
                {
                    $errorString = $cTrans->GetTranslation('admin_cat_errornameexists') . '!';
                    $b_ErrorOccured = true;
                }
            }
        }

        if ($b_ErrorOccured == false)
        {
            // If done, fill the rest of the parameters
            if ($catEdtAction == "new")    // New -> create Id first
            {
                $catCategory->CreateCategory();
                $catCategory->SetFolder($CATEGORY_FOLDER);
            }
            $catCategory->SetName($_POST['cat_Name']);
            $catCategory->SetDescription($_POST['cat_Description']);
            $catCategory->SetPosition($_POST['cat_Position']);
            if ($catCategory->SaveCategory() == false)
            {
                if ($catEdtAction == "new")
                    $errorString = $cTrans->GetTranslation('admin_catedt_errorcreate');
                else
                    $errorString = $cTrans->GetTranslation('admin_catedt_errorsave');
                $b_ErrorOccured = true;
            }
            else
            {
                if ($catEdtAction == "edit")
                {
                    // Category is saved.
                    log_message ('User ' . get_user_name() . ' saved category ' . $catCategory->GetId());
                    header ('Location: ' . $ADMIN_CATLIST_SITE);
                    return;
                }
                else
                    log_message ('User ' . get_user_name() . ' created category ' . $catCategory->GetId());

                $b_NotFinished = false;
            }
        }
    }

    // Display the input dialog for edit category
    $titleString = $cTrans->GetTranslation('admin_catedt_newhead');
    if ($catEdtAction == "edit")  // Edit
        $titleString = $cTrans->GetTranslation('admin_catedt_edithead');
    print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $ADMIN_CATLIST_SITE, $cTrans->GetTranslation('admin_catl_button'));
    print_help_link($ADMIN_HELP_FILE . '#n1-2', $cTrans->GetTranslation('admin_help'));
    if ($errorString !="")
        print_error_message($errorString);

    if ($b_NotFinished == false)
    {
        // Category is created. Display form to create another or go back to category list
        echo_r('<p>' . $cTrans->GetTranslation('admin_catedt_categorycreated') . ', ID : ' . $catCategory->GetId() . '<br></p>');
        print_bottom_links("cat_New", $cTrans->GetTranslation('admin_catedt_createanother'),
                           "cat_Cancel", $cTrans->GetTranslation('admin_ok'), true);
        return;
    }

    echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    if ($b_NotFinished == true)
    {
        echo_r('<table width="100%">');
        if ($catEdtAction == "edit")  // Edit
        {
            echo_r('  <tr>');
            echo_r('    <td>' . $cTrans->GetTranslation('admin_cat_id') . ':</td>');
            echo_r('    <td><b>' . $catCategory->GetId() . '</b>');
            echo_r('      <input type="hidden" value="' .  $catCategory->GetId() . '" name="cat_id">  ');
            echo_r('    </td>');
            echo_r('  </tr>');
        }
        echo_r('  <tr>');
        echo_r('    <td width="30%">' . $cTrans->GetTranslation('admin_cat_name') . ':</td>');
        if (isset($_POST['cat_Name']))
            echo_r('    <td><input type="text" name="cat_Name" value="' . $_POST['cat_Name'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="cat_Name" value="' .  $catCategory->GetName() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td width="30%">' . $cTrans->GetTranslation('admin_cat_description') . ':</td>');
        if (isset($_POST['cat_Description']))
            echo_r('    <td><input type="text" name="cat_Description" size="60" value="' . $_POST['cat_Description'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="cat_Description" size="60" value="' .  $catCategory->GetDescription() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td width="30%">' . $cTrans->GetTranslation('admin_cat_position') . ':</td>');
        if (isset($_POST['cat_Position']))
            echo_r('    <td><input type="text" name="cat_Position" size="3" value="' . $_POST['cat_Position'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="cat_Position" size="3"  value="' .  $catCategory->GetPosition() . '"></td>');
        echo_r('  </tr>');
        echo_r('</table>');

        if ($catEdtAction == "edit")  // Edit
            print_bottom_links("cat_Save", $cTrans->GetTranslation('admin_save'),
                               "cat_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
        else  // New
            print_bottom_links("cat_Save", $cTrans->GetTranslation('admin_create'),
                               "cat_Cancel", $cTrans->GetTranslation('admin_cancel'), false);

    }
    echo_r('<input type="hidden" name="cat_EdtAction" value="' . $catEdtAction . '">');
    echo_r('</form>');

    print_admin_footer();
?>