<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         list_orders.php
Description:  Administrative overview of all orders

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_order.php";
    include "../modules/class_article.php";
    include "../modules/class_orderlist.php";
    include "../modules/class_translation.php";
    
    //** UPDATE ORDER V1.100!!
    include "../modules/mod_updater.php";

    // Check privilege
    check_login();
    if (user_is_customer() || isset ($_POST['ordl_Cancel']))
    {
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Delete order?
    if (isset ($_POST['ordl_DeleteOrder']))
    {
        header ('Location: ' . $ADMIN_ORDEDT_SITE . '?id=' . $_POST['ordl_OrderId'] . '&action=delete');
        return;
    }

    // Order details?
    if (isset ($_POST['ordl_EditOrder']))
    {
        header ('Location: ' . $ADMIN_ORDEDT_SITE . '?id=' . $_POST['ordl_OrderId'] . '&action=edit');
        return;
    }

    // Display the order list
    print_admin_header($cTrans->GetTranslation('admin_ordl_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'));
    print_help_link($ADMIN_HELP_FILE . '#n1-3', $cTrans->GetTranslation('admin_help'));
    $ord = new cOrder;
    $ordList = new cOrderList;
    $art = new cArticle;
    $art->SetFolder($ARTICLE_FOLDER);
    $ordFilter = $FILTER_ALL;
    if (isset ($_GET['filter']) && $_GET['filter'] != "")
        $ordFilter = $_GET['filter'];
    else if (isset ($_POST['ordl_filter']) && $_POST['ordl_filter'] != "")
        $ordFilter = $_POST['ordl_filter'];

    $ord->SetFolder($ORDER_FOLDER);
    $ord->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $ordList->SetFolder($ORDER_FOLDER);

    $ordList->LoadOrderList($ordFilter);
    $list = $ordList->GetOrderList();
    rsort($list);

    echo_r ('<form method="post" action="">');
    echo_r ('<table border="0" width="100%">');
    echo_r ('<tr>');
    echo_r ('  <td width="20%">' . $cTrans->GetTranslation('admin_filter') . '</td>');
    echo_r ('  <td>');
    echo_r ('  <select name="ordl_filter" onChange="submit();">');
    echo   ('  <option value="' . $FILTER_ALL . '"');
    if ($ordFilter == $FILTER_ALL)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_all') . '</option>');
    echo   ('  <option value="' . $FILTER_DONE . '"');
    if ($ordFilter == $FILTER_DONE)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_ord_statedone') . '</option>');
    echo   ('  <option value="' . $FILTER_UNDONE . '"');
    if ($ordFilter == $FILTER_UNDONE)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_ord_stateundone') . '</option>');
    echo   ('  <option value="' . $FILTER_THISYEAR . '"');
    if ($ordFilter == $FILTER_THISYEAR)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_thisyear') . '</option>');
    echo   ('  <option value="' . $FILTER_THISMONTH . '"');
    if ($ordFilter == $FILTER_THISMONTH)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_thismonth') . '</option>');
    echo_r ('  </select>');
    echo_r ('  </td>');
    echo_r ('</tr>');
    echo_r ('</table>');
    echo_r ('</form>');
    $totalValue = -1;
    $totalArticles = 0;
    foreach ($list as $value)
    {
        $ord->LoadOrderFromId($value);
        
        echo_r('<hr>');
        echo_r('<table width="100%" border="0">');
        echo_r('  <tr>');
        echo_r('    <td width="16%">');
        echo  ('      <a href="' . $ADMIN_ORDEDT_SITE . '?id=' . $ord->GetId() . '&amp;action=edit">');
        echo_r('<img src="' . $ORDER_IMAGE . '" title="' . $cTrans->GetTranslation('admin_edit') .'" alt=""></a>');
        if ($ord->IsDone() == true)
            echo_r('      <img src="' . $DONE_IMAGE . '" title="' . $cTrans->GetTranslation('admin_ord_statedone') . '" alt="">');
        else
            echo_r('      <img src="' . $UNDONE_IMAGE . '" title="' . $cTrans->GetTranslation('admin_ord_stateundone') . '" alt="">');
        echo_r('    </td>');
        echo_r('    <td width="32%">');
        echo_r('       ' . $cTrans->GetTranslation('admin_ord_id') . ': ' . $ord->GetId() . '<br>');
        echo_r('       ' . $cTrans->GetTranslation('admin_ord_date') . ': ' . $ord->GetDate());
        echo_r('    </td>');
        echo_r('    <td width="32%">');
        // Update order?
        if ($ord->GetVersion() != $UPD_ORDER_VERSION)
        {
            if (order_update_from1000to1100($ord->GetId()) == true)
            {
                log_message ('User ' . get_user_name() . ' auto-order update to ' . $UPD_ORDER_VERSION . ': ' . $ord->GetId());
                $ord->LoadOrderFromId($ord->GetId());
            }
            else
                log_message ('User ' . get_user_name() . ' auto-order update to ' . $UPD_ORDER_VERSION . ' FAILED: ' . $ord->GetId());
        }
        $addValue = $ord->GetTotalOrderPrice();
        if ($totalValue == -1)
            $totalValue = 0;
        $totalValue = $totalValue + $addValue;
        $totalArticles = $totalArticles + $ord->GetTotalArticleCount();
        $addValue = format_price($addValue) . ' ' . $SHOP_CURRENCY;
        echo_r('       ' . $cTrans->GetTranslation('admin_ord_count') . ': ' . $ord->GetTotalArticleCount() . ', ' . $cTrans->GetTranslation('admin_ord_value') . ': ' . $addValue . '<br>');
        echo_r('       ' . $cTrans->GetTranslation('admin_ord_customer') . ': ' . $ord->GetFirstName() . ' ' . $ord->GetLastName() . ' (' . $ord->GetEmail() . ')<br>');
        echo_r('    </td>');
        echo_r('    <td width="20%">');
        echo_r('    <form method="post" action="">');
        echo_r('    <input type="hidden" value="' . $ord->GetId() . '" name="ordl_OrderId">  ');
        echo_r('    <input type="submit" class="side_btn" value="' . $cTrans->GetTranslation('admin_edit') . '" name="ordl_EditOrder">  ');
        echo_r('    <input type="submit" class="side_btn" value="' . $cTrans->GetTranslation('admin_delete') . '" name="ordl_DeleteOrder">  ');
        echo_r('    </form>');
        echo_r('    </td>');
        echo_r('  </tr>');
        echo_r('</table>');
    }
    if ($totalValue != -1)
    {
        echo_r('<hr>');
        echo_r('<p>' . $cTrans->GetTranslation('admin_ordl_summary') . ': <br>');
        echo_r($cTrans->GetTranslation('admin_ordl_articles') . ': <b>' . $totalArticles . '</b><br>');
        echo_r($cTrans->GetTranslation('admin_ordl_sales') . ': <b>' . format_price($totalValue) . ' ' . $SHOP_CURRENCY . '</b></p>');
    }
    print_bottom_links("ordl_Cancel", $cTrans->GetTranslation('admin_ok'));

    print_admin_footer();
?>